﻿' parameters: <text_to_twitter_or_push> | <send: yes, no, prowl> | <prowl app redirect name> | <prowl priority>
'-----------------------------------------------------------------------------------------------------------------------
'                       TWITTER & APNS integrtation with HOMESEER
' 	   	   by DJF3 - http://www.domoticaworld.com - info@domoticaworld.com
' version 0.5 - Mar-7 2011 (same as 0.4d)
'	Added feature to define the Prowl Event. Based on the Appliction name you can set triggers in your iPhone prowl app.
'	NOTE: this script is using supertweet.net for authentication. See website for more details!
' version 0.4c - Sep-9 2010
'	Added feature for APNS priority. Your Prowl client on the iphone could have a doorbell sound if you provide the matching priorities
' version 0.4b - Aug-17 2010 
'	Modified authentication to use api.supertweet.net (authorize this site first!) to work around the basic authentication being removed.
'	Replaced twitter.com:80 to api.supertweet.net/l/ (jruys) For instructions see website
' version 0.4 - Nov 09 2009
'	Updated traces to show "APNS" or "TWIT"
'	Update traces to show which 'counter' cycle it is going through
'	FIXED: when adding 2 strings/values/dates in 1 command it would only pick the first. 
'	FIXED: (Enver) "Telefoon op dd[hh:mm DDD, D MMM YYYY] 18:25 maandag, 8 november 2009" --> 8 november=zondag
'	BUG Enver: doesn't accept devices that start with '(' and probably also ')' - not fixed yet
' version 0.3 - Sep 17 2009
'	Added support for Growl Apple Push Notification Service
' version 0.2 - Sep 6 2009
'	Added variables for 'wget.exe' path and Twitter username and password
'	Fine-tuned debug levels (0, 1 or 2)
'	Planned to: remove requirement for space after vv/ss<devicecode>, add option for date and time (seperately), add special character for ss/vv/date/time (feedback jruys)
'	Removed "Add Date" parameter. Use the "dd[<dateformat>]" instead
'	Added code that checks if the device exists or not
' version 0.1 - May 22 2009
'	The string send to twitter will be stripped of HTML tags. (important for device-strings) 
'PARAMETERS:
'	strTwitter: text you want to send. use 
'		'vv[<device>]' to insert VALUE of a HS device 
'		'ss[<device>]' to insert the device STRING
'		'dd[<dateformat>] to insert a date. <dateformat> can contain D=day, DD=day-short, DDD=day-full, M=month, MM=month-short, MMM=month-full, 
'			YYYY=year, hh=hours, mm=minutes and characters like / - : etc
'	strSend: (optional) actually send the twitt? 
'		yes = send the twitt
'		no = do not send it (for troubleshooting purposes, it only appears in the HS log) 
'		prowl = send to Prowl Notification Service (APNS) for iPhone
'	strApp: Application name (Prowl client external redirections: App.Name="Doorbell", Event="My Home")
'			reason for switching App and Event is that App appears bold and easy to read in the Prowl client. Trust me.
'	strPriority: (optional, default=0)
'	   			2=VeryLow   -1=Moderate  0=Normal  1=High   2=Emergency

'TODO (see http://www.domoticaworld.com for detailed instructions)
' 	Download wget and put in HomeSeer directory
' 	Change the variables below 
'
'  Example: ("Main","Front door is ss[^7] and the temperature is vv[T8] on dd[DDD, D MMM YYYY]")
'  Example: ("Main","The temperature is vv[T8] |no") (if you only want to log the event and not actually send it)
'
'--------------------------------------------------------------------------------------------------------------------------------------------------


sub Main(byVal parm As Object)

dim strDebug as String
dim strTwitter,strTwitDate as String
dim strSend as String
dim varCounter, varVersion as String
dim vvStart, vvEnd, Counter as Integer
dim ssStart, ssEnd as Integer
dim ddStart, ddEnd as Integer
dim strPriority,strApp as String
dim strTwitterUser, strTwitterPwd, strWGETdirectory as String

'DJ: PROWL integration code
dim apiKey as String
dim description as String
dim strEvent as String
dim response,url as String
'====== PROWL VARIABLES for iPhone Push Notifications =================
apiKey = "enter_your_prowl_API_key_here"	'apiKey - request at Prowl website
strApp = ""												'strApp description (appears on Push notifications)
strEvent = "My Home"									'event description (appears on Push notifications)
	
'====== TWITTER VARIABLES =============================================

strWGETdirectory = "C:\Program Files\HomeSeer 2\"
strTwitterUser = "enter_twitter_userid_here"
strTwitterPwd = "enter_supertweet.net_password_here"
strDebug = 1
'====== END of configurable parameters

varVersion = "0.5"

strTwitter = hs.stringitem(parm, 1, "|")
strSend = hs.stringitem(parm, 2, "|")
' DJ: NEW to set priority. If not used priority 0 is used.
strApp = hs.stringitem(parm, 3, "|") 
strPriority = hs.stringitem(parm, 4, "|") 

If strPriority = "" then strPriority = "0"
If strSend = "" then strSend = "yes"
varVersion = "DJ_Twitter_" + varVersion
If strDebug > 0 then hs.writelog(varVersion,"<b><font color=blue>Starting " + varVersion)

'DJ:======================= DD = DATE and/or TIME ===========================
ddStart = instr(strTwitter,"dd[")+3
varCounter = ubound(split(lcase(strTwitter), lcase("dd[")))
If strDebug > 1  and varCounter > 0 then hs.writelog(varVersion,"<font color=red><b>TOTAL DD="+Cstr(varCounter)+"</b></font>")
ddStart = instr(strTwitter,"dd[")+3
Counter = 0
While Counter < varCounter
	ddEnd = (instr(ddStart+1, strTwitter, "]"))- ddStart
	If strDebug > 1 then hs.writelog(varVersion,"dd start:" + Cstr(ddStart) + "   ddend:" + Cstr(ddEnd))
	If strDebug > 1 then hs.writelog(varVersion,"dd strTwitter="+strTwitter)
    If strDebug > 1 then hs.writelog(varVersion,"dd Device:" + Mid(strTwitter, ddStart,	ddEnd) + ":")
	strTwitDate = Mid(strTwitter, ddStart, ddEnd)
	'DJ: Fixed bug found by Enver: in 2 lines below added ',1'.
	strTwitDate = Replace(strTwitDate,"DDD",WeekDayName(Weekday(Now),FALSE,1))
	strTwitDate = Replace(strTwitDate,"DD",WeekDayName(Weekday(Now),TRUE,1))
	strTwitDate = Replace(strTwitDate,"D",Cstr(Day(Now)))
	
	strTwitDate = Replace(strTwitDate,"MMM",MonthName(Month(Now),FALSE))
	strTwitDate = Replace(strTwitDate,"MM",MonthName(Month(Now),TRUE))
	strTwitDate = Replace(strTwitDate,"M",Cstr(Month(Now)))
	
	strTwitDate = Replace(strTwitDate,"YYYY",Cstr(Year(Now)))
	
	strTwitDate = Replace(strTwitDate,"hh",Cstr(Hour(Now)))
	If len(Cstr(Minute(Now))) < 2 then 			'DJ:  If the minutes are < 10, prefix a '0'. Otherwise the time is 14:5 instead of 14:05
		strTwitDate = Replace(strTwitDate,"mm","0"+Cstr(Minute(Now)))
	Else
		strTwitDate = Replace(strTwitDate,"mm",Cstr(Minute(Now)))
	End if
	If strDebug > 1 then hs.writelog(varVersion,"strTwitDate:" + strTwitDate)
	strTwitter = replace(strTwitter, Mid(strTwitter, ddStart-3, ddEnd+4), strTwitDate)
	Counter = Counter + 1
	If strDebug > 1 then hs.writelog(varVersion,"dd Counter:" + Cstr(Counter))
	ddStart = instr(strTwitter,"dd[")+3
	If strDebug > 0 then hs.writelog(varVersion,"dd strTwitter="+strTwitter)
End While



'DJ:======================= VV = VALUE ===========================
varCounter = ubound(split(lcase(strTwitter), lcase("vv[")))
If strDebug > 1 and varCounter > 0 then hs.writelog(varVersion,"<font color=red><b>TOTAL VV="+Cstr(varCounter)+"</b></font>")
vvStart = instr(strTwitter,"vv[")+3
Counter = 0
While Counter < varCounter
	vvEnd = (instr(vvStart+1, strTwitter, "]"))- vvStart
	If strDebug > 1 then hs.writelog(varVersion,"COUNT"+Cstr(Counter)+": vv start:" + Cstr(vvStart) + "   vvend:" + Cstr(vvEnd))
	If strDebug > 1 then hs.writelog(varVersion,"COUNT"+Cstr(Counter)+": vv strTwitter="+strTwitter)
    If strDebug > 1 then hs.writelog(varVersion,"COUNT"+Cstr(Counter)+": vv Device:" + Mid(strTwitter, vvStart,	vvEnd) + ":")
	If strDebug > 0 then hs.writelog(varVersion,"device id: " + Mid(strTwitter, vvStart, vvEnd) + " which means it exists:" + Cstr(hs.deviceexistsref(Mid(strTwitter, vvStart, vvEnd))))
	If hs.deviceexistsref(Mid(strTwitter, vvStart, vvEnd)) <> -1 then 
		strTwitter = replace(strTwitter, Mid(strTwitter, vvStart-3, vvEnd+4), Cstr(hs.devicevalue(Mid(strTwitter, vvStart, vvEnd))))
	Else
		hs.writelog(varVersion,"COUNT"+Cstr(Counter)+": ERROR value: device " + Mid(strTwitter, vvStart, vvEnd) + " does not exist")
		strTwitter = replace(strTwitter, Mid(strTwitter, vvStart-3, vvEnd+4), "WRONG_DEVICE")
	End if
	Counter = Counter + 1
	If strDebug > 1 then hs.writelog(varVersion,"vv Counter:" + Cstr(Counter))
	vvStart = instr(strTwitter,"vv[")+3
	If strDebug > 0 then hs.writelog(varVersion,"vv strTwitter="+strTwitter)
End While


'DJ:======================= ss = STRING ===========================
varCounter = ubound(split(lcase(strTwitter), lcase("ss[")))
If strDebug > 1  and varCounter > 0 then hs.writelog(varVersion,"<font color=red><b>TOTAL SS="+Cstr(varCounter)+"</b></font>")
ssStart = instr(strTwitter,"ss[")+3
Counter = 0
While Counter < varCounter
	ssEnd = (instr(ssStart+1, strTwitter, "]"))- ssStart
	If strDebug > 1 then hs.writelog(varVersion,"COUNT"+Cstr(Counter)+": ss start:" + Cstr(ssStart) + "   ssend:" + Cstr(ssEnd))
	If strDebug > 1 then hs.writelog(varVersion,"COUNT"+Cstr(Counter)+": ss strTwitter="+strTwitter)
    If strDebug > 1 then hs.writelog(varVersion,"COUNT"+Cstr(Counter)+": ss Device:" + Mid(strTwitter, ssStart,	ssEnd) + ":")
	'DJ: added 'TRIM' to remove spaces before and after HTML-stripped string (feedback jruys)
	If strDebug > 0 then hs.writelog(varVersion,"device id: " + Mid(strTwitter, ssStart, ssEnd) + " which means it exists:" + Cstr(hs.deviceexistsref(Mid(strTwitter, ssStart, ssEnd))))
	
	If hs.deviceexistsref(Mid(strTwitter, ssStart, ssEnd)) <> -1 then 
		strTwitter = Trim(stripHTML(replace(strTwitter, Mid(strTwitter, ssStart-3, ssEnd+4), hs.devicestring(Mid(strTwitter, ssStart, ssEnd)))))
	Else
		hs.writelog(varVersion,"COUNT"+Cstr(Counter)+": ERROR string: device " + Mid(strTwitter, ssStart, ssEnd) + " does not exist")
		strTwitter = Replace(strTwitter, Mid(strTwitter, ssStart-3, ssEnd+4), "WRONG_DEVICE")
	End if
	Counter = Counter + 1
	If strDebug > 1 then hs.writelog(varVersion,"ss Counter updated to:" + Cstr(Counter) + " ... ssStart:"+Cstr(ssStart))
	ssStart = instr(strTwitter,"ss[")+3
	If strDebug > 1 then hs.writelog(varVersion,"COUNT"+Cstr(Counter)+": ssStart:"+Cstr(ssStart)+"... ssEnd:"+Cstr(ssEnd))
	If strDebug > 0 then hs.writelog(varVersion,"ss strTwitter="+strTwitter)
End While

'DJ:======================= SENDING INFO (TWIT/APNS)  ===========================
If strDebug > 0 and strSend = "yes" then hs.writelog(varVersion,"<b>FINAL, TWIT sending:</b>"+strTwitter)
If strDebug > 0 and strSend = "prowl" then hs.writelog(varVersion,"<b>FINAL, APNS sending:</b>"+strTwitter)
If strSend = "yes" then 
	If strDebug > 1 then hs.writelog(varVersion,"Sending is turned <b>ON</b>")
	If len(strTwitter) < 150 then
		If strDebug > 1  then hs.writelog(varVersion,"CALLING: hs.launch('"+strWGETdirectory+"wget.exe','--keep-session-cookies --quiet --http-user="+strTwitterUser+" --http-password=******* --post-data=status=+chr(34)+"+strTwitter+"+chr(34)+http://api.supertweet.net/1/statuses/update.xml")
		hs.launch(strWGETdirectory & "wget.exe","--keep-session-cookies --quiet --http-user="+strTwitterUser+" --http-password="+strTwitterPwd+" --post-data=status="+chr(34)+strTwitter+chr(34)+" http://api.supertweet.net/1/statuses/update.xml")
	Else
		hs.writelog(varVersion,"<b><font color=red>Error: Twitts cannot exceed 150 characters. This one was "+Cstr(len(strTwitter))+"</b></font><br>String:" + strTwitter+ "<end>")
		strTwitter = replace(strTwitter, Mid(strTwitter, vvStart-3, vvEnd+4), "<wrong device>")
	End if
else if strSend = "prowl" then '=================  Push Notification ===================
	If strDebug > 1 then hs.writelog(varVersion,"PROWL Sending is turned <b>ON</b>")
	If len(strTwitter) < 150 then
		url = "https://prowl.weks.net/publicapi/add?apikey="+apiKey+"&application="+strApp+"&event="+strEvent+"&description="+strTwitter+"&priority="+strPriority
		' DJ: Above: added strPriority
		response = hs.URLAction(url, "GET", "", "")
	Else
		hs.writelog(varVersion,"<b><font color=red>Error: Prowls cannot exceed 150 characters. This one was "+Cstr(len(strTwitter))+"</b></font><br>String:" + strTwitter+ "<end>")
	end if
else
	hs.writelog(varVersion,"Posting has been turned <b>OFF</b>")
End if 

end sub


Function stripHTML(strHTML)
  If len(strHTML) = 0 then
    stripHTML = strHTML
    Exit Function
  End If
  dim arysplit, i, j, strOutput
  arysplit = split(strHTML, "<")
  if len(arysplit(0)) > 0 then j = 1 else j = 0
  for i=j to ubound(arysplit)
     if instr(arysplit(i), ">") then
       arysplit(i) = mid(arysplit(i), instr(arysplit(i), ">") + 1)
     else
       arysplit(i) = "<" & arysplit(i)
     end if
  next
  strOutput = join(arysplit, "")
  strOutput = mid(strOutput, 2-j)
  strOutput = replace(strOutput,">",">")
  strOutput = replace(strOutput,"<","<")
  stripHTML = Replace(Replace(strOutput, Chr(194), ""), Chr(160), "")
End Function
